.TH http 3 "inets  5.1.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
http \- An HTTP/1\&.1 client 
.SH DESCRIPTION
.LP
This module provides the API to a HTTP/1\&.1 client according to RFC 2616, caching is currently not supported\&.
.SS Note:
.LP
When starting the Inets application a manager process for the default profile will be started\&. The functions in this API that does not explicitly use a profile will acesses the default profile\&. A profile keeps track of proxy options, cookies and other options that can be applied to more than one request\&. 
.LP
If the scheme https is used the ssl application needs to be started\&.
.LP
Also note that pipeling will only be used if the pipeline timeout is set, otherwise persistent connections without pipeling will be used e\&.i\&. the client always waits for the previous response before sending the next request\&.

.LP
There are some usage examples in the Inets User\&'s Guide\&.

.SH COMMON DATA TYPES 
.LP
Type definitions that are used more than once in this module:

.nf
boolean()    = true | false 
string()     = list of ASCII characters 
request_id() = ref() 
profile()    = atom()
path()       = string() representing a file path or directory path 
ip_address() = See inet(3)
    
.fi
.SH HTTP DATA TYPES 
.LP
Type definitions that are related to HTTP:
.LP
For more information about HTTP see rfc 2616

.nf
method()        = head | get | put | post | trace | options | delete
request()       = {url(), headers()} | 
                  {url(), headers(), content_type(), body()}
url()           = string() - Syntax according to the URI definition in rfc 2396, ex: "http://www\&.erlang\&.org"
status_line()   = {http_version(), status_code(), reason_phrase()}
http_version()  = string() ex: "HTTP/1\&.1"
status_code()   = integer()
reason_phrase() = string()
content_type()  = string()
headers()       = [header()]
header()        = {field(), value()}
field()         = string() 
value()         = string() 
body()          = string() | binary() 
filename()      = string() 
    
.fi
.SH SSL DATA TYPES 
.LP
Some type definitions relevant when using https, for details ssl(3): 

.nf
ssl_options() = {verify,     code()}   | 
                {depth,      depth()}  | 
                {certfile,   path()}   | 
                {keyfile,    path()}   | 
                {password,   string()} | 
                {cacertfile, path()}   | 
                {ciphers,    string()} 
    
.fi
.SH HTTP CLIENT SERVICE START/STOP 
.LP
A HTTP client can be configured to start when starting the inets application or started dynamically in runtime by calling the inets application API \fIinets:start(httpc, ServiceConfig)\fR, or \fIinets:start(httpc, ServiceConfig, How)\fR see inets(3) Below follows a description of the available configuration options\&.
.RS 2
.TP 4
.B
{profile, profile()}:
Name of the profile, see common data types below, this option is mandantory\&.
.TP 4
.B
{data_dir, path()}:
Directory where the profile may save persistent data, if omitted all cookies will be treated as session cookies\&.
.RE
.LP
The client can be stopped using inets:stop(httpc, Pid) or inets:stop(httpc, Profile)\&.
.SH EXPORTS
.LP
.B
cancel_request(RequestId) -> 
.br
.B
cancel_request(RequestId, Profile) -> ok
.br
.RS
.TP
Types
RequestId = request_id() - A unique identifier as returned by request/4
.br
Profile = profile()
.br
.RE
.RS
.LP
Cancels an asynchronous HTTP-request\&. 
.RE
.LP
.B
request(Url) -> 
.br
.B
request(Url, Profile) -> {ok, Result} | {error, Reason}
.br
.RS
.TP
Types
Url = url() 
.br
Result = {status_line(), headers(), body()} | {status_code(), body()} | request_id() 
.br
Profile = profile()
.br
Reason = term() 
.br
.RE
.RS
.LP
Equivalent to http:request(get, {Url, []}, [], [])\&.
.RE
.LP
.B
request(Method, Request, HTTPOptions, Options) -> 
.br
.B
request(Method, Request, HTTPOptions, Options, Profile) -> {ok, Result} | {ok, saved_to_file} | {error, Reason}
.br
.RS
.TP
Types
Method = method() 
.br
Request = request()
.br
HTTPOptions = http_options()
.br
http_options() = [http_option()]
.br
http_option() = {timeout, timeout()} | {connect_timeout, timeout()} | {ssl, ssl_options()} | {autoredirect, boolean()} | {proxy_auth, {userstring(), passwordstring()}} | {version, http_version()} | {relaxed, boolean()}
.br
timeout() = integer() >= 0 | infinity
.br
Options = options()
.br
options() = [option()]
.br
option() = {sync, boolean()} | {stream, stream_to()} | {body_format, body_format()} | {full_result, boolean()} | {headers_as_is, boolean()}
.br
stream_to() = self | {self, once} | filename() 
.br
body_format() = string() | binary() 
.br
Result = {status_line(), headers(), body()} | {status_code(), body()} | request_id() 
.br
Profile = profile() 
.br
Reason = term() 
.br
.RE
.RS
.LP
Sends a HTTP-request\&. The function can be both synchronous and asynchronous\&. In the later case the function will return {ok, RequestId} and later on message(s) will be sent to the calling process on the format: 

.nf
          {http, {RequestId, Result}}
          {http, {RequestId, {error, Reason}}}
          {http, {RequestId, stream_start, Headers}
          {http, {RequestId, stream, BinBodyPart}
          {http, {RequestId, stream_end, Headers}
          {http, {RequestId, saved_to_file}}\&.

.fi
.LP
Http option (\fIhttp_option()\fR) details: 
.RS 2
.TP 4
.B
\fItimeout\fR:
Timeout time for the request\&. 
.RS 4
.LP

.LP
Defaults to \fIinfinity\fR\&. 
.RE
.TP 4
.B
\fIconnect_timeout\fR:
Connection timeout time, used during the initial request, when the client is connecting to the server\&. 
.RS 4
.LP

.LP
Defaults to the value of the \fItimeout\fR option\&. 
.RE
.TP 4
.B
\fIssl\fR:
If using SSL, these SSL-specific options are used\&. 
.RS 4
.LP

.LP
Defaults to \fI[]\fR\&. 
.RE
.TP 4
.B
\fIautoredirect\fR:
Should the client automatically retreive the information from the new URI and return that as the result instead of a 30X-result code\&. 
.RS 4
.LP

.LP
Note that for some 30X-result codes automatic redirect is not allowed in these cases the 30X-result will always be returned\&. 
.LP

.LP
Defaults to \fItrue\fR\&. 
.RE
.TP 4
.B
\fIproxy_auth\fR:
A proxy-authorization header using the provided user name and password will be added to the request\&. 
.TP 4
.B
\fIversion\fR:
Can be used to make the client act as an \fIHTTP/1\&.0\fR or \fIHTTP/0\&.9\fR client\&. By default this is an \fIHTTP/1\&.1\fR client\&. When using \fIHTTP/1\&.0\fR persistent connections will not be used\&. 
.RS 4
.LP

.LP
Defaults to the trsing \fI"HTTP/1\&.1"\fR\&. 
.RE
.TP 4
.B
\fIrelaxed\fR:
If set to true workarounds for known server deviations from the HTTP-standard are enabled\&. 
.RS 4
.LP

.LP
Defaults to \fIfalse\fR\&. 
.RE
.RE
.LP
Option (\fIoption()\fR) details: 
.RS 2
.TP 4
.B
\fIsync\fR:
Shall the request be synchronous or asynchronous\&. 
.RS 4
.LP

.LP
Defaults to \fItrue\fR\&. 
.RE
.TP 4
.B
\fIstream\fR:
Streams the body of a 200 or 206 response to the calling process or to a file\&. When streaming to the calling process using the option \fIself\fR the the following stream messages will be sent to that process: {http, {RequestId, stream_start, Headers}, {http, {RequestId, stream, BinBodyPart}, {http, {RequestId, stream_end, Headers}\&. When streaming to to the calling processes using the option \fI{self once}\fR the first message will have an additional element e\&.i\&. {http, {RequestId, stream_start, Headers, Pid}, this is the process id that should be used as an argument to http:stream_next/1 to trigger the next message to be sent to the calling process\&. 
.RS 4
.LP

.LP
Note that it is possible that chunked encoding will add headers so that there are more headers in the stream_end message than in the stream_start\&. When streaming to a file and the request is asynchronous the message {http, {RequestId, saved_to_file}} will be sent\&. 
.LP

.LP
Defaults to \fInone\fR\&. 
.RE
.TP 4
.B
\fIbody_format\fR:
Defines if the body shall be delivered as a string or as a binary\&. This option is only valid for the synchronous request\&. 
.RS 4
.LP

.LP
Defaults to \fIstring\fR\&. 
.RE
.TP 4
.B
\fIfull_result\fR:
Should a "full result" be returned to the caller (that is, the body, the headers and the entire status-line) or not (the body and the status code)\&. 
.RS 4
.LP

.LP
Defaults to \fItrue\fR\&. 
.RE
.TP 4
.B
\fIheader_as_is\fR:
Shall the headers provided by the user be made lower case or be regarded as case sensitive\&. 
.RS 4
.LP

.LP
Note that the http standard requires them to be case insenstive\&. This feature should only be used if there is no other way to communicate with the server or for testing purpose\&. Also note that when this option is used no headers will be automatically added, all necessary headers has to be provided by the user\&. 
.LP

.LP
Defaults to \fIfalse\fR\&. 
.RE
.RE
.RE
.LP
.B
set_options(Options) -> 
.br
.B
set_options(Options, Profile) -> ok | {error, Reason}
.br
.RS
.TP
Types
Options = [Option]
.br
Option = {proxy, {Proxy, NoProxy}} | {max_sessions, MaxSessions} | {max_keep_alive_length, MaxKeepAlive} | {keep_alive_timeout, KeepAliveTimeout} | {max_pipeline_length, MaxPipeline} | {pipeline_timeout, PipelineTimeout} | {cookies | CookieMode} | {ipfamily, IpFamily} | {ip, IpAddress} | {port, Port} | {verbose, VerboseMode} 
.br
Proxy = {Hostname, Port}
.br
Hostname = string() 
.br
  ex: "localhost" or "foo\&.bar\&.se"
.br
Port = integer()
.br
  ex: 8080 
.br
NoProxy = [NoProxyDesc]
.br
NoProxyDesc = DomainDesc | HostName | IPDesc
.br
DomainDesc = "*\&.Domain"
.br
  ex: "*\&.ericsson\&.se"
.br
IpDesc = string()
.br
  ex: "134\&.138" or "[FEDC:BA98" (all IP-adresses starting with 134\&.138 or FEDC:BA98), "66\&.35\&.250\&.150" or "[2010:836B:4179::836B:4179]" (a complete IP-address)\&.
.br
MaxSessions = integer() 
.br
  Default is \fI2\fR\&. Maximum number of persistent connections to a host\&.
.br
MaxKeepAlive = integer() 
.br
  Default is \fI5\fR\&. Maximum number of outstanding requests on the same connection to a host\&.
.br
KeepAliveTimeout = integer() 
.br
  Default is \fI120000\fR (= 2 min)\&. If a persistent connection is idle longer than the keep_alive_timeout the client will close the connection\&. The server may also have a such a time out but you should not count on it!
.br
MaxPipeline = integer() 
.br
  Default is \fI2\fR\&. Maximum number of outstanding requests on a piplined connection to a host\&.
.br
PipelineTimeout = integer() 
.br
  Default is \fI0\fR, which will result in pipeling not being used\&. If a persistent connection is idle longer than the pipeline_timeout the client will close the connection\&. 
.br
CookieMode = enabled | disabled | verify 
.br
  Default is \fIdisabled\fR\&. If Cookies are enabled all valid cookies will automatically be saved in the client manager\&'s cookie database\&. If the option verify is used the function http:verify_cookie/2 has to be called for the cookie to be saved\&.
.br
IpFamily = inet | inet6 | inet6fb4 
.br
  By default \fIinet\fR\&. When it is set to \fIinet6fb4\fR you can use both ipv4 and ipv6\&. It first tries \fIinet6\fR and if that does not works falls back to \fIinet\fR\&. The option is here to provide a workaround for buggy ipv6 stacks to ensure that ipv4 will always work\&.
.br
IpAddress = ip_address() 
.br
  If the host has several network interfaces, this option specifies which one to use\&. See gen_tcp:connect/3,4 for more info\&. 
.br
Port = integer() 
.br
  Specify which local port number to use\&. See gen_tcp:connect/3,4 for more info\&. 
.br
VerboseMode = false | verbose | debug | trace 
.br
  Default is \fIfalse\fR\&. This option is used to switch on (or off) different levels of erlang trace on the client\&. It is a debug feature\&.
.br
Profile = profile()
.br
.RE
.RS
.LP
Sets options to be used for subsequent requests\&.
.SS Note:
.LP
If possible the client will keep its connections alive and use persistent connections with or without pipeline depending on configuration and current circumstances\&. The HTTP/1\&.1 specification does not provide a guideline for how many requests that would be ideal to be sent on a persistent connection, this very much depends on the application\&. Note that a very long queue of requests may cause a user perceived delays as earlier request may take a long time to complete\&. The HTTP/1\&.1 specification does suggest a limit of 2 persistent connections per server, which is the default value of the max_sessions option\&. 

.RE
.LP
.B
stream_next(Pid) -> ok
.br
.RS
.TP
Types
Pid = pid() - as received in the stream_start message
.br
.RE
.RS
.LP
Triggers the next message to be streamed, e\&.i\&. same behavior as active once for sockets\&.
.RE
.LP
.B
verify_cookie(SetCookieHeaders, Url) -> 
.br
.B
verify_cookie(SetCookieHeaders, Url, Profile) -> ok | {error, Reason}
.br
.RS
.TP
Types
SetCookieHeaders = headers() - where field = "set-cookie"
.br
Url = url()
.br
Profile = profile()
.br
.RE
.RS
.LP
Saves the cookies defined in SetCookieHeaders in the client profile\&'s cookie database\&. You need to call this function if you set the option cookies to verify\&. If no profile is specifed the default profile will be used\&. 
.RE
.LP
.B
cookie_header(Url) -> 
.br
.B
cookie_header(Url, Profile) -> header() | {error, Rason}
.br
.RS
.TP
Types
Url = url()
.br
Profile = profile()
.br
.RE
.RS
.LP
Returns the cookie header that would be sent when making a request to Url using the profile Profile\&. If no profile is specifed the default profile will be used\&. 
.RE
.SH SEE ALSO
.LP
RFC 2616, inets(3), ssl(3) 
